<?php
// script to prevent when exterior temperature become inferior or superior to interior one
class rdc_temperature_int_ext extends hook
{
	public $hookName = "rdc_temperature_int_ext";
	public $active = true;			//enable/disable hook (true => enabled)
	public $tempSup = 25;
	public $tempInf = 20;


	protected $devicelist = array(
				METEO=> "tempc",
				);

	protected $portesList = array(
		ENTREE_PORTE => "contact",
		//GARAGE_PORTE => "contact",
		RDC_CHAMBRE_BAIE => "contact",
		RDC_SALON_BAIE => "contact"
	);

	function installHooks(&$indexDevices)
	{
		return $this->installHooksFunction($indexDevices);
	}

	// callback fonction. Is called with these 4 parameters
	public function callBack(&$device, $property, $value)
	{
		global $indexDevices, $hooks;
		static $time;
		$portes = array();
		$status = -1;
		$msg = "";

		logger(DEBUG, _("rdc_temperature_int_ext hook"), null ,$device);

		if (empty($time))	$time = now();
		//echo  "Time is " . var_dump($time) . EOL;
		//echo "minutes since time :" . now()->format("U") - $time->format("U");
		if ((now()->format("U") - $time->format("U")) > 300)
		{

			$indoorTemp = $device->properties["indoortempc"]["value"];


			if ( $value > $indoorTemp)
			{
				if( ($indoorTemp <= $this->tempSup) and empty($portes))
				{
					$status = 1;
					//logger(ALERT, _("Open doors to climate"), null ,$device);
				}elseif($indoorTemp >= $this -> tempSup and ! empty($portes))
				{
					$status = 0;
					//logger(ALERT, _("Close doors to climate"), null, $device);
				}
			}elseif ( $value < $indoorTemp )
			{
				if (($indoorTemp >= $this->tempSup) and empty($portes) )
				{
					$status = 1;
					//logger(ALERT, _("Open doors to climate"), null ,$device);
				}elseif ($indoorTemp <= $this->tempSup)
				{
					$status = 0;
					//logger(ALERT, _("Close doors to climate"), null, $device);
				}
				logger (INFO, sprintf(_("%s: notification received from MQTT from %s => parameter: %s value: %s"), $this->hookName, $device->friendlyName, $property, bool2string($value)), __FILE__ . ":" . __LINE__, $device);
			}
			$portes = $hooks["alerte_intrusion"]->testPortes($this->portesList, false, true);
			print_r($portes);
			if ($status == 1)
			{
				if (empty($portes))
				{
					logger(ALERT, _("Open doors to climate"), null, $device);
					$time = now();
				}
			}else
			{
				//$portes = $hooks["alerte_intrusion"]->testPortes(false, true);
				if (!empty($portes))
				{
					$time = now();
					foreach($portes as $porte)
					{
						$msg .= $porte . "\n";
					}
					logger(ALERT, _("Close doors to climate\n") . $msg, null, $device);
				}
			}
		}
	}
}
$hooks["rdc_temperature_int_ext"] = new rdc_temperature_int_ext();
?>
